package com.somex.app.network.generated;

//Copyright (c) 2016. SomexTech, Inc.
//Genereated by "C:\\ToggleboltSW\\Clients\\somextech\\Tools\\Generation\\webservices\\Generators\\GenerateGeneric.php" on UTC: 2017/03/15 21:47:53

import com.somex.app.tasks.support.logger;
import org.json.JSONObject;
import org.json.JSONArray;
import java.util.ArrayList;

public class SOMEX_Account_Info{
    protected String mAccount_id = "";
protected String mEmail = "";
protected String mContact_method = "";


    public SOMEX_Account_Info(){
    }

    public SOMEX_Account_Info(JSONObject json){
        from_Json(json);
    }

    
    public void set_account_id(String value){
        try {
            mAccount_id = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_email(String value){
        try {
            mEmail = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_contact_method(String value){
        try {
            mContact_method = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }


    
    public String get_account_id(){
        return mAccount_id;
    }

    public String get_email(){
        return mEmail;
    }

    public String get_contact_method(){
        return mContact_method;
    }


    public String to_Json(boolean encloseInBraces){
        StringBuilder data = new StringBuilder();
        try{
            if (encloseInBraces){
                data.append("{");
            }
            
            //SOMEX_FIELD_ACCOUNT_ID//
            data.append("\"accid\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_account_id());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_ACCOUNT_EMAIL//
            data.append("\"email\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_email());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_ACCOUNT_CONTACT_METHOD//
            data.append("\"method\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_contact_method());
            data.append("\"");

            if (encloseInBraces){
                data.append("}");
            }
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data.toString();
    }


    
    public SOMEX_Account_Info from_Json(JSONObject json){
        try{
            if (json == null){
                json = new JSONObject();
            }
            //mJson = json;
            
        //Extracting:account_id
        mAccount_id = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_ACCOUNT_ID.getJsonTag(),"");

        //Extracting:email
        mEmail = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_ACCOUNT_EMAIL.getJsonTag(),"");

        //Extracting:contact_method
        mContact_method = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_ACCOUNT_CONTACT_METHOD.getJsonTag(),"");

        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return this;
    }


    
    public String extractFieldString(JSONObject json, String key, String defaultValue){
        String data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getString(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public int extractFieldInteger(JSONObject json, String key, int defaultValue){
        int data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getInt(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public double extractFieldDouble(JSONObject json, String key, int defaultValue){
        double data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getDouble(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public boolean extractFieldBoolean(JSONObject json, String key, boolean defaultValue){
        boolean data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getBoolean(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONObject extractFieldJson(JSONObject json, String key){
        JSONObject data = new JSONObject();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONObject(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONArray extractFieldJsonArray(JSONObject json, String key){
        JSONArray data = new JSONArray();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONArray(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

}
