package com.somex.app.network.generated;

//Copyright (c) 2016. SomexTech, Inc.
//Genereated by "C:\\ToggleboltSW\\Clients\\somextech\\Tools\\Generation\\webservices\\Generators\\GenerateGeneric.php" on UTC: 2017/03/15 21:47:53

import com.somex.app.tasks.support.logger;
import org.json.JSONObject;
import org.json.JSONArray;
import java.util.ArrayList;

public class SOMEX_App_Info{
    protected String mName = "";
protected String mPackage = "";
protected String mProduct = "";
protected String mVersion = "";
protected int mBuild = 0;


    public SOMEX_App_Info(){
    }

    public SOMEX_App_Info(JSONObject json){
        from_Json(json);
    }

    
    public void set_name(String value){
        try {
            mName = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_package(String value){
        try {
            mPackage = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_product(String value){
        try {
            mProduct = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_version(String value){
        try {
            mVersion = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_build(int value){
        try {
            mBuild = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }


    
    public String get_name(){
        return mName;
    }

    public String get_package(){
        return mPackage;
    }

    public String get_product(){
        return mProduct;
    }

    public String get_version(){
        return mVersion;
    }

    public int get_build(){
        return mBuild;
    }


    public String to_Json(boolean encloseInBraces){
        StringBuilder data = new StringBuilder();
        try{
            if (encloseInBraces){
                data.append("{");
            }
            
            //SOMEX_FIELD_APP_NAME//
            data.append("\"appname\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_name());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_APP_PACKAGE//
            data.append("\"apppackage\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_package());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_APP_PRODUCT//
            data.append("\"appproduct\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_product());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_APP_VERSION//
            data.append("\"appversion\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_version());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_APP_BUILD//
            data.append("\"appbuild\"");
            data.append(":");
            data.append(this.get_build());

            if (encloseInBraces){
                data.append("}");
            }
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data.toString();
    }


    
    public SOMEX_App_Info from_Json(JSONObject json){
        try{
            if (json == null){
                json = new JSONObject();
            }
            //mJson = json;
            
        //Extracting:name
        mName = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_APP_NAME.getJsonTag(),"");

        //Extracting:package
        mPackage = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_APP_PACKAGE.getJsonTag(),"");

        //Extracting:product
        mProduct = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_APP_PRODUCT.getJsonTag(),"");

        //Extracting:version
        mVersion = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_APP_VERSION.getJsonTag(),"");

        //Extracting:build
        mBuild = extractFieldInteger(json, SOMEX_Fields.SOMEX_FIELD_APP_BUILD.getJsonTag(),0);

        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return this;
    }


    
    public String extractFieldString(JSONObject json, String key, String defaultValue){
        String data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getString(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public int extractFieldInteger(JSONObject json, String key, int defaultValue){
        int data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getInt(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public double extractFieldDouble(JSONObject json, String key, int defaultValue){
        double data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getDouble(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public boolean extractFieldBoolean(JSONObject json, String key, boolean defaultValue){
        boolean data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getBoolean(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONObject extractFieldJson(JSONObject json, String key){
        JSONObject data = new JSONObject();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONObject(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONArray extractFieldJsonArray(JSONObject json, String key){
        JSONArray data = new JSONArray();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONArray(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

}
