package com.somex.app.network.generated;

//Copyright (c) 2016. SomexTech, Inc.
//Genereated by "C:\\ToggleboltSW\\Clients\\somextech\\Tools\\Generation\\webservices\\Generators\\GenerateGeneric.php" on UTC: 2017/03/15 21:47:54

import com.somex.app.tasks.support.logger;
import org.json.JSONObject;
import org.json.JSONArray;
import java.util.ArrayList;

public class SOMEX_Locale{
    protected String mIso3country = "";
protected String mIso3language = "";


    public SOMEX_Locale(){
    }

    public SOMEX_Locale(JSONObject json){
        from_Json(json);
    }

    
    public void set_iso3country(String value){
        try {
            mIso3country = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_iso3language(String value){
        try {
            mIso3language = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }


    
    public String get_iso3country(){
        return mIso3country;
    }

    public String get_iso3language(){
        return mIso3language;
    }


    public String to_Json(boolean encloseInBraces){
        StringBuilder data = new StringBuilder();
        try{
            if (encloseInBraces){
                data.append("{");
            }
            
            //SOMEX_FIELD_LOCALE_ISO3COUNTRY//
            data.append("\"country\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_iso3country());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_LOCALE_ISO3LANGUAGE//
            data.append("\"lang\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_iso3language());
            data.append("\"");

            if (encloseInBraces){
                data.append("}");
            }
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data.toString();
    }


    
    public SOMEX_Locale from_Json(JSONObject json){
        try{
            if (json == null){
                json = new JSONObject();
            }
            //mJson = json;
            
        //Extracting:iso3country
        mIso3country = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_LOCALE_ISO3COUNTRY.getJsonTag(),"");

        //Extracting:iso3language
        mIso3language = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_LOCALE_ISO3LANGUAGE.getJsonTag(),"");

        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return this;
    }


    
    public String extractFieldString(JSONObject json, String key, String defaultValue){
        String data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getString(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public int extractFieldInteger(JSONObject json, String key, int defaultValue){
        int data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getInt(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public double extractFieldDouble(JSONObject json, String key, int defaultValue){
        double data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getDouble(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public boolean extractFieldBoolean(JSONObject json, String key, boolean defaultValue){
        boolean data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getBoolean(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONObject extractFieldJson(JSONObject json, String key){
        JSONObject data = new JSONObject();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONObject(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONArray extractFieldJsonArray(JSONObject json, String key){
        JSONArray data = new JSONArray();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONArray(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

}
