package com.somex.app.network.generated;

//Copyright (c) 2016. SomexTech, Inc.
//Genereated by "C:\\ToggleboltSW\\Clients\\somextech\\Tools\\Generation\\webservices\\Generators\\GenerateGeneric.php" on UTC: 2017/03/15 21:47:55

import com.somex.app.tasks.support.logger;
import org.json.JSONObject;
import org.json.JSONArray;
import java.util.ArrayList;

public class SOMEX_Response{
    protected String mStatus = "";
protected String mPayload = "";


    public SOMEX_Response(){
    }

    public SOMEX_Response(JSONObject json){
        from_Json(json);
    }

    
    public void set_status(String value){
        try {
            mStatus = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_payload(String value){
        try {
            mPayload = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }


    
    public String get_status(){
        return mStatus;
    }

    public String get_payload(){
        return mPayload;
    }


    public String to_Json(boolean encloseInBraces){
        StringBuilder data = new StringBuilder();
        try{
            if (encloseInBraces){
                data.append("{");
            }
            
            //SOMEX_FIELD_STATUS//
            data.append("\"status\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_status());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_PAYLOAD//
            data.append("\"payload\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_payload());
            data.append("\"");

            if (encloseInBraces){
                data.append("}");
            }
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data.toString();
    }


    
    public SOMEX_Response from_Json(JSONObject json){
        try{
            if (json == null){
                json = new JSONObject();
            }
            //mJson = json;
            
        //Extracting:status
        mStatus = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_STATUS.getJsonTag(),"");

        //Extracting:payload
        mPayload = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_PAYLOAD.getJsonTag(),"");

        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return this;
    }


    
    public String extractFieldString(JSONObject json, String key, String defaultValue){
        String data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getString(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public int extractFieldInteger(JSONObject json, String key, int defaultValue){
        int data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getInt(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public double extractFieldDouble(JSONObject json, String key, int defaultValue){
        double data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getDouble(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public boolean extractFieldBoolean(JSONObject json, String key, boolean defaultValue){
        boolean data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getBoolean(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONObject extractFieldJson(JSONObject json, String key){
        JSONObject data = new JSONObject();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONObject(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONArray extractFieldJsonArray(JSONObject json, String key){
        JSONArray data = new JSONArray();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONArray(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

}
