package com.somex.app.network.generated;

//Copyright (c) 2016. SomexTech, Inc.
//Genereated by "C:\\ToggleboltSW\\Clients\\somextech\\Tools\\Generation\\webservices\\Generators\\GenerateServerStatus.php" on UTC: 2017/03/15 21:47:53

import android.content.Context;
import com.somex.app.R;
import com.somex.app.tasks.support.logger;

public enum SOMEX_Status{
    
   SERVER_STATUS_SUCCESS(R.string.SERVER_STATUS_SUCCESS, 0),
   SERVER_STATUS_REQUEST_INVALID_FORMAT(R.string.SERVER_STATUS_REQUEST_INVALID_FORMAT, 10),
   SERVER_STATUS_REQUEST_TRANSMISSION_ERROR(R.string.SERVER_STATUS_REQUEST_TRANSMISSION_ERROR, 15),
   SERVER_STATUS_REQUEST_TIMEOUT(R.string.SERVER_STATUS_REQUEST_TIMEOUT, 20),
   SERVER_STATUS_REQUEST_INVALID(R.string.SERVER_STATUS_REQUEST_INVALID, 25),
   SERVER_STATUS_REQUEST_EMPTY(R.string.SERVER_STATUS_REQUEST_EMPTY, 30),
   SERVER_STATUS_REQUEST_MISSING_ORIGINATOR(R.string.SERVER_STATUS_REQUEST_MISSING_ORIGINATOR, 35),
   SERVER_STATUS_REQUEST_PAYLOAD_EMPTY(R.string.SERVER_STATUS_REQUEST_PAYLOAD_EMPTY, 40),
   SERVER_STATUS_REQUEST_PAYLOAD_INVALID(R.string.SERVER_STATUS_REQUEST_PAYLOAD_INVALID, 45),
   SERVER_STATUS_TOKEN_INVALID(R.string.SERVER_STATUS_TOKEN_INVALID, 70),
   SERVER_STATUS_TOKEN_EXPIRED(R.string.SERVER_STATUS_TOKEN_EXPIRED, 71),
   SERVER_STATUS_REGISTRATION_MISSING(R.string.SERVER_STATUS_REGISTRATION_MISSING, 80),
   SERVER_STATUS_REGISTRATION_SUSPENDED(R.string.SERVER_STATUS_REGISTRATION_SUSPENDED, 81),
   SERVER_STATUS_REGISTRATION_NEEDS_CONFIRM(R.string.SERVER_STATUS_REGISTRATION_NEEDS_CONFIRM, 82),
   SERVER_STATUS_REGISTRATION_INVALID(R.string.SERVER_STATUS_REGISTRATION_INVALID, 83),
   SERVER_STATUS_RESPONSE_EMPTY(R.string.SERVER_STATUS_RESPONSE_EMPTY, 100),
   SERVER_STATUS_RESPONSE_INVALID(R.string.SERVER_STATUS_RESPONSE_INVALID, 105),
   SERVER_STATUS_DEVICE_NOT_FOUND(R.string.SERVER_STATUS_DEVICE_NOT_FOUND, 200),
   SERVER_STATUS_DEVICE_INVALID(R.string.SERVER_STATUS_DEVICE_INVALID, 210),
   SERVER_STATUS_DEVICE_NOT_ACTIVE(R.string.SERVER_STATUS_DEVICE_NOT_ACTIVE, 215),
   SERVER_STATUS_DEVICE_ID_INVALID(R.string.SERVER_STATUS_DEVICE_ID_INVALID, 220),
   SERVER_STATUS_DEVICE_TYPE_INVALID(R.string.SERVER_STATUS_DEVICE_TYPE_INVALID, 225),
   SERVER_STATUS_DEVICE_VERSION_INVALID(R.string.SERVER_STATUS_DEVICE_VERSION_INVALID, 230),
   SERVER_STATUS_DEVICE_NOTIFICATION_ID_INVALID(R.string.SERVER_STATUS_DEVICE_NOTIFICATION_ID_INVALID, 235),
   SERVER_STATUS_DEVICE_OS_INVALID(R.string.SERVER_STATUS_DEVICE_OS_INVALID, 240),
   SERVER_STATUS_DEVICE_OWNER_INVALID(R.string.SERVER_STATUS_DEVICE_OWNER_INVALID, 245),
   SERVER_STATUS_DEVICE_DUPLICATE(R.string.SERVER_STATUS_DEVICE_DUPLICATE, 250),
   SERVER_STATUS_ACCOUNT_NOT_FOUND(R.string.SERVER_STATUS_ACCOUNT_NOT_FOUND, 300),
   SERVER_STATUS_ACCOUNT_NOT_ACTIVE(R.string.SERVER_STATUS_ACCOUNT_NOT_ACTIVE, 305),
   SERVER_STATUS_ACCOUNT_INVALID(R.string.SERVER_STATUS_ACCOUNT_INVALID, 310),
   SERVER_STATUS_ACCOUNT_DUPLICATE(R.string.SERVER_STATUS_ACCOUNT_DUPLICATE, 315),
   SERVER_STATUS_ACCOUNT_USERNAME_INVALID(R.string.SERVER_STATUS_ACCOUNT_USERNAME_INVALID, 320),
   SERVER_STATUS_ACCOUNT_EMAIL_INVALID(R.string.SERVER_STATUS_ACCOUNT_EMAIL_INVALID, 325),
   SERVER_STATUS_ACCOUNT_PHONE_INVALID(R.string.SERVER_STATUS_ACCOUNT_PHONE_INVALID, 330),
   SERVER_STATUS_NETWORK_LIST_EMPTY(R.string.SERVER_STATUS_NETWORK_LIST_EMPTY, 400),
   SERVER_STATUS_NETWORK_LIST_INVALID(R.string.SERVER_STATUS_NETWORK_LIST_INVALID, 405),
   SERVER_STATUS_NETWORK_NOT_DEFINED(R.string.SERVER_STATUS_NETWORK_NOT_DEFINED, 410),
   SERVER_STATUS_NETWORK_CREDENTIALS_INVALID(R.string.SERVER_STATUS_NETWORK_CREDENTIALS_INVALID, 415),
   SERVER_STATUS_NETWORK_BEFRIEND_REDIRECT(R.string.SERVER_STATUS_NETWORK_BEFRIEND_REDIRECT, 420),
   SERVER_STATUS_NOTIFICATION_INVALID_JSON(R.string.SERVER_STATUS_NOTIFICATION_INVALID_JSON, 500),
   SERVER_STATUS_NOTIFICATION_INVALID_SENDER(R.string.SERVER_STATUS_NOTIFICATION_INVALID_SENDER, 505),
   SERVER_STATUS_NOTIFICATION_SERVER_ERR(R.string.SERVER_STATUS_NOTIFICATION_SERVER_ERR, 510),
   SERVER_STATUS_SERVER_ERROR(R.string.SERVER_STATUS_SERVER_ERROR, 9999),

    ENUM_LOOKUP_ERROR(-1,-1);

    private int statusStringResourceId;
    private int intCode;

    private SOMEX_Status(int resourceId, int code) {
        statusStringResourceId = resourceId;
        intCode = code;
    }

    public static SOMEX_Status getEnum(int value){
        for(SOMEX_Status v : values()){
            if( v.getCode()==(value)){
                return v;
            }
        }
        return  ENUM_LOOKUP_ERROR;
    }

    public boolean isCode(int code) {
        return intCode == code;
    }

    public int getCode() {
        return intCode;
    }

    public int getStringResourceId() {
        return statusStringResourceId;
    }

    public String getStatusDescription(Context context){
        String result = "";
        try{
            result = context.getResources().getString(statusStringResourceId);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return result;
    }
}
