package com.somex.app.network.generated;

//Copyright (c) 2016. SomexTech, Inc.
//Genereated by "C:\\ToggleboltSW\\Clients\\somextech\\Tools\\Generation\\webservices\\Generators\\GenerateGeneric.php" on UTC: 2017/03/15 21:47:53

import com.somex.app.tasks.support.logger;
import org.json.JSONObject;
import org.json.JSONArray;
import java.util.ArrayList;

public class SOMEX_Address{
    protected String mStreet1 = "";
protected String mStreet2 = "";
protected String mCity = "";
protected String mState = "";
protected String mPostal = "";
protected String mCountry = "";


    public SOMEX_Address(){
    }

    public SOMEX_Address(JSONObject json){
        from_Json(json);
    }

    
    public void set_street1(String value){
        try {
            mStreet1 = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_street2(String value){
        try {
            mStreet2 = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_city(String value){
        try {
            mCity = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_state(String value){
        try {
            mState = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_postal(String value){
        try {
            mPostal = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_country(String value){
        try {
            mCountry = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }


    
    public String get_street1(){
        return mStreet1;
    }

    public String get_street2(){
        return mStreet2;
    }

    public String get_city(){
        return mCity;
    }

    public String get_state(){
        return mState;
    }

    public String get_postal(){
        return mPostal;
    }

    public String get_country(){
        return mCountry;
    }


    public String to_Json(boolean encloseInBraces){
        StringBuilder data = new StringBuilder();
        try{
            if (encloseInBraces){
                data.append("{");
            }
            
            //SOMEX_FIELD_ADDR_STREET1//
            data.append("\"street1\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_street1());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_ADDR_STREET2//
            data.append("\"street2\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_street2());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_ADDR_CITY//
            data.append("\"city\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_city());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_ADDR_STATE//
            data.append("\"state\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_state());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_ADDR_POSTAL//
            data.append("\"postal\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_postal());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_ADDR_COUNTRY//
            data.append("\"country\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_country());
            data.append("\"");

            if (encloseInBraces){
                data.append("}");
            }
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data.toString();
    }


    
    public SOMEX_Address from_Json(JSONObject json){
        try{
            if (json == null){
                json = new JSONObject();
            }
            //mJson = json;
            
        //Extracting:street1
        mStreet1 = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_ADDR_STREET1.getJsonTag(),"");

        //Extracting:street2
        mStreet2 = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_ADDR_STREET2.getJsonTag(),"");

        //Extracting:city
        mCity = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_ADDR_CITY.getJsonTag(),"");

        //Extracting:state
        mState = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_ADDR_STATE.getJsonTag(),"");

        //Extracting:postal
        mPostal = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_ADDR_POSTAL.getJsonTag(),"");

        //Extracting:country
        mCountry = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_ADDR_COUNTRY.getJsonTag(),"");

        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return this;
    }


    
    public String extractFieldString(JSONObject json, String key, String defaultValue){
        String data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getString(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public int extractFieldInteger(JSONObject json, String key, int defaultValue){
        int data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getInt(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public double extractFieldDouble(JSONObject json, String key, int defaultValue){
        double data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getDouble(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public boolean extractFieldBoolean(JSONObject json, String key, boolean defaultValue){
        boolean data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getBoolean(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONObject extractFieldJson(JSONObject json, String key){
        JSONObject data = new JSONObject();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONObject(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONArray extractFieldJsonArray(JSONObject json, String key){
        JSONArray data = new JSONArray();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONArray(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

}
