package com.somex.app.network.generated;

//Copyright (c) 2016. SomexTech, Inc.
//Genereated by "C:\\ToggleboltSW\\Clients\\somextech\\Tools\\Generation\\webservices\\Generators\\GenerateGeneric.php" on UTC: 2017/03/15 21:47:54

import com.somex.app.tasks.support.logger;
import org.json.JSONObject;
import org.json.JSONArray;
import java.util.ArrayList;

public class SOMEX_Location{
    protected double mLatitude = 0;
protected double mLongitude = 0;
protected int mRadius = 0;


    public SOMEX_Location(){
    }

    public SOMEX_Location(JSONObject json){
        from_Json(json);
    }

    
    public void set_latitude(double value){
        try {
            mLatitude = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_longitude(double value){
        try {
            mLongitude = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_radius(int value){
        try {
            mRadius = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }


    
    public double get_latitude(){
        return mLatitude;
    }

    public double get_longitude(){
        return mLongitude;
    }

    public int get_radius(){
        return mRadius;
    }


    public String to_Json(boolean encloseInBraces){
        StringBuilder data = new StringBuilder();
        try{
            if (encloseInBraces){
                data.append("{");
            }
            
            //SOMEX_FIELD_LATITUDE//
            data.append("\"latitude\"");
            data.append(":");
            data.append(this.get_latitude());
            data.append(",");
            
            //SOMEX_FIELD_LONGITUDE//
            data.append("\"longitude\"");
            data.append(":");
            data.append(this.get_longitude());
            data.append(",");
            
            //SOMEX_FIELD_RADIUS//
            data.append("\"radius\"");
            data.append(":");
            data.append(this.get_radius());

            if (encloseInBraces){
                data.append("}");
            }
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data.toString();
    }


    
    public SOMEX_Location from_Json(JSONObject json){
        try{
            if (json == null){
                json = new JSONObject();
            }
            //mJson = json;
            
        //Extracting:latitude
        mLatitude = extractFieldDouble(json, SOMEX_Fields.SOMEX_FIELD_LATITUDE.getJsonTag(),0);

        //Extracting:longitude
        mLongitude = extractFieldDouble(json, SOMEX_Fields.SOMEX_FIELD_LONGITUDE.getJsonTag(),0);

        //Extracting:radius
        mRadius = extractFieldInteger(json, SOMEX_Fields.SOMEX_FIELD_RADIUS.getJsonTag(),0);

        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return this;
    }


    
    public String extractFieldString(JSONObject json, String key, String defaultValue){
        String data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getString(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public int extractFieldInteger(JSONObject json, String key, int defaultValue){
        int data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getInt(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public double extractFieldDouble(JSONObject json, String key, int defaultValue){
        double data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getDouble(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public boolean extractFieldBoolean(JSONObject json, String key, boolean defaultValue){
        boolean data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getBoolean(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONObject extractFieldJson(JSONObject json, String key){
        JSONObject data = new JSONObject();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONObject(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONArray extractFieldJsonArray(JSONObject json, String key){
        JSONArray data = new JSONArray();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONArray(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

}
