package com.somex.app.network.generated;

//Copyright (c) 2016. SomexTech, Inc.
//Genereated by "C:\\ToggleboltSW\\Clients\\somextech\\Tools\\Generation\\webservices\\Generators\\GenerateGeneric.php" on UTC: 2017/03/15 21:47:53

import com.somex.app.tasks.support.logger;
import org.json.JSONObject;
import org.json.JSONArray;
import java.util.ArrayList;

public class SOMEX_Originator{
    protected String mDevice_id = "";
protected SOMEX_App_Info mApp_info = new SOMEX_App_Info();
protected SOMEX_Location mLocation = new SOMEX_Location();


    public SOMEX_Originator(){
    }

    public SOMEX_Originator(JSONObject json){
        from_Json(json);
    }

    
    public void set_device_id(String value){
        try {
            mDevice_id = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_app_info(SOMEX_App_Info value){
        try {
            mApp_info = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }

    public void set_location(SOMEX_Location value){
        try {
            mLocation = value;
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
    }


    
    public String get_device_id(){
        return mDevice_id;
    }

    public SOMEX_App_Info get_app_info(){
        if (mApp_info == null){
          mApp_info = new SOMEX_App_Info();
        }
        return mApp_info;
    }

    public SOMEX_Location get_location(){
        if (mLocation == null){
          mLocation = new SOMEX_Location();
        }
        return mLocation;
    }


    public String to_Json(boolean encloseInBraces){
        StringBuilder data = new StringBuilder();
        try{
            if (encloseInBraces){
                data.append("{");
            }
            
            //SOMEX_FIELD_DEVICE_ID//
            data.append("\"deviceid\"" );
            data.append(":");
            data.append("\"");
            data.append(this.get_device_id());
            data.append("\"");
            data.append(",");
            
            //SOMEX_FIELD_APP_INFO//
            SOMEX_App_Info mApp_info = this.get_app_info();
            data.append("\"app\"");
            data.append(":");
            data.append(mApp_info.to_Json(true));
            data.append(",");
            
            //SOMEX_FIELD_LOCATION//
            SOMEX_Location mLocation = this.get_location();
            data.append("\"geo\"");
            data.append(":");
            data.append(mLocation.to_Json(true));

            if (encloseInBraces){
                data.append("}");
            }
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data.toString();
    }


    
    public SOMEX_Originator from_Json(JSONObject json){
        try{
            if (json == null){
                json = new JSONObject();
            }
            //mJson = json;
            
        //Extracting:device_id
        mDevice_id = extractFieldString(json, SOMEX_Fields.SOMEX_FIELD_DEVICE_ID.getJsonTag(),"");

        //Extracting:app_info
        JSONObject tmp_app_info = extractFieldJson(json, SOMEX_Fields.SOMEX_FIELD_APP_INFO.getJsonTag());
        if (mApp_info == null){
            mApp_info = new SOMEX_App_Info();
        }
        mApp_info= mApp_info.from_Json(tmp_app_info);

        //Extracting:location
        JSONObject tmp_location = extractFieldJson(json, SOMEX_Fields.SOMEX_FIELD_LOCATION.getJsonTag());
        if (mLocation == null){
            mLocation = new SOMEX_Location();
        }
        mLocation= mLocation.from_Json(tmp_location);

        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return this;
    }


    
    public String extractFieldString(JSONObject json, String key, String defaultValue){
        String data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getString(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public int extractFieldInteger(JSONObject json, String key, int defaultValue){
        int data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getInt(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public double extractFieldDouble(JSONObject json, String key, int defaultValue){
        double data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getDouble(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public boolean extractFieldBoolean(JSONObject json, String key, boolean defaultValue){
        boolean data = defaultValue;
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getBoolean(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONObject extractFieldJson(JSONObject json, String key){
        JSONObject data = new JSONObject();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONObject(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

    public JSONArray extractFieldJsonArray(JSONObject json, String key){
        JSONArray data = new JSONArray();
        try{
            if (!json.has(key)){
                return data;
            }
            data = json.getJSONArray(key);
        }catch(Exception e){
            logger.error(this.getClass(), e, "Exception: %s", e.getCause());
        }
        return data;
    }

}
